    MODULE quad_1d_ex06_mod

      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Default Accessibility ..
      PUBLIC
      ! .. Intrinsic Functions ..
      INTRINSIC KIND
      ! .. Parameters ..
      INTEGER, PARAMETER :: wp = KIND(1.0D0)

    CONTAINS

      FUNCTION f(x)

        ! .. Implicit None Statement ..
        IMPLICIT NONE
        ! .. Intrinsic Functions ..
        INTRINSIC COS, SIN, SIZE
        ! .. Array Arguments ..
        REAL (wp), INTENT (IN) :: x(:)
        ! .. Function Return Value ..
        REAL (wp) :: f(SIZE(x))
        ! .. Executable Statements ..
        f = x*SIN(30.0_wp*x)*COS(x)

      END FUNCTION f

    END MODULE quad_1d_ex06_mod

    PROGRAM nag_quad_1d_ex06

      ! Example Program Text for nag_quad_1d
      ! NAG fl90, Release 4. NAG Copyright 2000.

      ! .. Use Statements ..
      USE nag_examples_io, ONLY : nag_std_out
      USE nag_math_constants, ONLY : nag_pi
      USE nag_quad_1d, ONLY : nag_quad_1d_gen
      USE quad_1d_ex06_mod, ONLY : wp, f
      ! .. Implicit None Statement ..
      IMPLICIT NONE
      ! .. Local Scalars ..
      INTEGER :: rule
      REAL (wp) :: a, b, pi, result
      ! .. Executable Statements ..
      WRITE (nag_std_out,*) 'Example Program Results for nag_quad_1d_ex06'

      pi = nag_pi(0.0_wp)
      a = 0.0_wp
      b = 2.0_wp*pi
      rule = 6

      CALL nag_quad_1d_gen(f,a,b,result,rule=rule)

      WRITE (nag_std_out,'(/,1X,A,F10.4)') &
       'a  - lower limit of integration = ', a
      WRITE (nag_std_out,'(1X,A,F10.4)') 'b  - upper limit of integration = ', b
      WRITE (nag_std_out,'(1X,A,F9.5)') &
       'result - approximation to the integral =', result

    END PROGRAM nag_quad_1d_ex06
